### **一、功能概述**

 - **订单业务**：CRM订单管理系统可以实现订单的自动创建、处理、跟踪和关闭，整合销售、供应链和客户支持等业务流程。同时，也能通过分析订单的历史数据，总结出订单的特点和规律，帮助企业更好地制定销售策略和优惠政策。
 - **出库业务**：CRM系统通过库存管理功能，可以实时掌握库存情况，当订单被确认后，系统会自动进行库存扣减，并生成出库单。出库单会详细列出需要出库的产品、数量、批次等信息，以便仓库人员按照出库单进行拣货和发货，打通物流与库存的边界，形成业务流通。
 - **退货业务**：当客户需要退货时，可以通过CRM系统提交退货申请。系统会自动审核退货申请，并生成退货单。退货单会详细列出退货的产品、数量、原因等信息。仓库人员收到退货后，会进行验收并更新库存信息。
 - **退换货业务**：退换货业务是退货业务和出库业务的结合。当客户需要退换货时，可以先通过CRM系统提交退货申请并完成退货流程。然后，客户可以重新下单购买需要的产品，CRM系统会再次进行出库流程，将新的产品发送给客户。

### 二、核心服务说明
<table>
	<tbody>
		<tr>
			<th>
				类名
			</th>
			<th>
				类说明
			</th>
			<th>
				请求类型
			</th>
			<th>
				请求地址
			</th>
			<th>
				接口说明
			</th>
		</tr>
		<tr>
			<td rowspan="62" >
				
					OrderErpRest
				
			</td>
			<td rowspan="62" >
				订单
			</td>
			<td >
				POST
			</td>
			<td >
				
					/api/ordererp/getlistnew
				
			</td>
			<td colspan="1" >
				
					查询所有订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlistnew/my
				
			</td>
			<td colspan="1" >
				
					查询我的订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlistnew/share
				
			</td>
			<td colspan="1" >
				
					查询别人共享给我的客户订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlistnew/mydept
				
			</td>
			<td colspan="1" >
				
					查询我负责部门订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlistnew/myjoin
				
			</td>
			<td colspan="1" >
				
					查询我参与部门订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlistnew/service
				
			</td>
			<td colspan="1" >
				
					查询所有的服务订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlistnew/asset
				
			</td>
			<td colspan="1" >
				
					查询所有的资产订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlist
				
			</td>
			<td colspan="1" >
				
					查询所有的订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlist/my
				
			</td>
			<td colspan="1" >
				
					查询我的订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlist/share
				
			</td>
			<td colspan="1" >
				
					查询别人共享给我的订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlist/mydept
				
			</td>
			<td colspan="1" >
				
					查询我负责部门的订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlist/myjoin
				
			</td>
			<td colspan="1" >
				
					查询我参与的订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getlist/service
				
			</td>
			<td colspan="1" >
				
					查询我参与的订单列表数据（服务订单）
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/homeorder4Mobile
				
			</td>
			<td colspan="1" >
				
					查询生科订单首页指标信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/advance
				
			</td>
			<td colspan="1" >
				
					根据条件查询预付款余额列表
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/listAdvance
				
			</td>
			<td colspan="1" >
				
					根据条件查询预付款余额列表
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getorderinfo
				
			</td>
			<td colspan="1" >
					根据订单编号查询订单及其详情信息
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getorderinfo/{id}
				
			</td>
			<td colspan="1" >
				
					根据订单id查询订单及其详情信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getbyordercode
				
			</td>
			<td colspan="1" >
				
					根据订单编号查询订单信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/get/{id}
				
			</td>
			<td colspan="1" >
				
					根据订单id查询订单信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				/api/ordererp/save
			</td>
			<td colspan="1" >
				
					保存订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				/api/ordererp/save4Mobile
			</td>
			<td colspan="1" >
				
					保存订单（手机端）
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/deletebyid
				
			</td>
			<td colspan="1" >
				
					根据id删除订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getadvancelist
				
			</td>
			<td colspan="1" >
				
					根据租户ID和客户编码查询该客户所有预付款余额大于0的预付款订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/checklowerprice
				
			</td>
			<td colspan="1" >
				
					查验商品是否有需要低价处理的商品
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/checklowerpriceForModify
				
			</td>
			<td colspan="1" >
				
					查验商品是否有需要低价处理的商品
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/closeorder
				
			</td>
			<td colspan="1" >
				
					根据订单编号关闭订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/modifydetail
				
			</td>
			<td colspan="1" >
				
					修改订单明细
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				/api/ordererp/createspecialorder
			</td>
			<td colspan="1" >
				
					创建特殊订单（-G、-C）订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/saveandcheck
				
			</td>
			<td colspan="1" >
				
					新增对象并发起低价审批
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/lowerFlowSubmit
				
			</td>
			<td colspan="1" >
				
					处理低价审批流程
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/dealOrderDetail
				
			</td>
			<td colspan="1" >
				
					处理待办需要审批的订单详情信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/returnofclose
				
			</td>
			<td colspan="1" >
				
					退货关闭订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getstock
				
			</td>
			<td colspan="1" >
				
					获取当前明细的库存
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/judgedownstream
				
			</td>
			<td colspan="1" >
				
					根据订单编码判断该订单是否有下游单据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getprogressbyid/{id}
				
			</td>
			<td colspan="1" >
				
					根据订单ID查询订单进展信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/update
				
			</td>
			<td colspan="1" >
				
					更新订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getadvancebymodify
				
			</td>
			<td colspan="1" >
				
					修改订单明细时查询预付款明细
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getalldetailsbycodes
				
			</td>
			<td colspan="1" >
				
					根据订单code集合查询所有的订单明细
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/checkorderstock
				
			</td>
			<td colspan="1" >
				
					提交之前检查库存是否足够
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/modifySale
				
			</td>
			<td colspan="1" >
				
					修改现销售
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/initInvorderWriteamount
				
			</td>
			<td colspan="1" >
				
					初始化预开票发货订单的收款金额
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/modifyOrderDetail
				
			</td>
			<td colspan="1" >
				
					修改订单的订单状态，出库状态，开票状态，未出库金额，未开票金额，价税合计，实际价税合计信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/initOrderWriteamountByWhere
				
			</td>
			<td colspan="1" >
				
					根据开票年份、开票月份初始化订单的收款金额、收款情况
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/checkBatchLock
				
			</td>
			<td colspan="1" >
				
					校验是否存在批次锁定客户的订单明细在ERP的待发库里存在库存
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/initActMoney
				
			</td>
			<td colspan="1" >
				
					运维工具计算实际出库金额
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/getOrderErpByOrderCode
				
			</td>
			<td colspan="1" >
				
					根据订单编号获取订单编码列表
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getorderprogress
				
			</td>
			<td colspan="1" >
				
					根据订单id查询订单进展
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/get4Mobile/{id}
				
			</td>
			<td colspan="1" >
				
					根据id获取订单信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					GET
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/sendlessmsg
				
			</td>
			<td colspan="1" >
				
					检查订单明细是否缺货并通知POM
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				
					POST
				
			</td>
			<td colspan="1" >
				
					/api/ordererp/getFullactivityList/my
				
			</td>
			<td colspan="1" >
				
					查询我的全线订单列表数据
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/isInvoiced
				
			</td>
			<td colspan="1" >
				
					是否开票
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/sapAdd
				
			</td>
			<td colspan="1" >
				
					对接sap新增订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/sapUpdate
				
			</td>
			<td colspan="1" >
				
					对接sap更新订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/sapDelete
				
			</td>
			<td colspan="1" >
				
					对接sap删除订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/sapClose
				
			</td>
			<td colspan="1" >
				
					对接sap关闭订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/findOrderByProductCode
				
			</td>
			<td colspan="1" >
				
					根据定制产品编码查询订单信息
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				POST
			</td>
			<td colspan="1" >
				
					/api/ordererp/check
				
			</td>
			<td colspan="1" >
				
					校验明细是否包含需要弱提示的货号
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/initProductType
				
			</td>
			<td colspan="1" >
				
					初始化产品类型
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/listAssert/{instrumentCode}
				
			</td>
			<td colspan="1" >
				
					根据仪器下单编码获取其下的所有资产订单
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/privew/{orderCode}
				
			</td>
			<td colspan="1" >
				
					预览订单invoice
				
			</td>
		</tr>
		<tr>
			<td colspan="1" >
				GET
			</td>
			<td colspan="1" >
				
					/api/ordererp/downloadInvoice/{orderCode}
				
			</td>
			<td colspan="1" >
				
					下载订单invoice
				
			</td>
		</tr>
	</tbody>
</table>


### 三、数据库设计
![输入图片说明](/imgs/2024-02-26/zEMchSXOG3lTAz26.jpeg)
### 四、代码运行截图
![输入图片说明](/imgs/2024-02-26/S9LSKlxBUTuARe05.png)
<!--stackedit_data:
eyJoaXN0b3J5IjpbMTkwOTI0NTc5LDIxMjYwNjU2MjksMjA2Mz
Y4OTU5MiwtNzc0MDY5NTg1LC0xODg2NDYyMDA0LC0xMDA2NTA1
MTIyLC0xODUzMzY2Njc1LDcwMjYyNTY3Niw2NTExOTEyOTAsLT
E0ODIwNzYzMjMsMzI1NzMwMDMyLC0xNjgzODU4MjYsMjgyNDAw
MDI3LDE4NjU5NzQ4MDYsMTM3NDY0NDE4MCwtMjc3MzM1MDUsLT
IwNjU3Mjc1MzksLTUxNjQyODA2XX0=
-->